<?php

namespace Drupal\currencyapi;

use Drupal\Core\State\StateInterface;

/**
 * Provides currency exchange rates from CurrencyAPI.com.
 */
class CurrencyApiCron {

  /**
   * Constructs a new FileExampleHelper object.
   *
   * @param \Drupal\Core\State\StateInterface $state
   *   The state.
   */
  public function __construct(protected StateInterface $state) {
    $this->state = $state;
  }

  /**
   * Cron the task.
   */
  public function cron() {
    $now = \Drupal::time()->getRequestTime();
    if ($this->shouldRun($now)) {
      $this->queueTasks();
      $this->state->set('currencyapi.last_cron', $now);
    }
  }

  /**
   * Check is to be run.
   */
  public function shouldRun($now) {

    $d = [];

    $d['now'] = $now;
    $d['timestamp_last'] = $this->state->get('currencyapi.last_cron') ?? 0;

    if ($d['now'] > ($d['timestamp_last'] + (86400 * 1))) {
      return FALSE;
    }
    else {
      return TRUE;
    }

  }

  /**
   * Queue manager.
   */
  public function queueTasks() {
    $d = [];
    $d['service'] = \Drupal::service('currencyapi.service');
    $d['fetch_rates'] = $d['service']->fetchExchangeRates();
  }

}
